/*      */
/*     Written by Vladimir Belov                               */
/*          foxii@bk.ru                                        */
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   
//    
#include <mega32.h>
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////  
//  
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////  
//   
#define number_scan_size 3                   //     (   !!!)
//  
#define key_1 PIND.4 
#define key_2 PIND.5 
//     
#define key_1R PORTD.4 
#define key_2R PORTD.5 
//      
#define key_1_DR DDRD.4
#define key_2_DR DDRD.5  
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
void init_key (void)   //        
{
 key_1_DR=0; //    1  
 key_2_DR=0; //    2  
 // 
 key_1R=1;   //     VCC  
 key_2R=1;   //     VCC  
} 
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
// 
unsigned char N_scan=0;                    //  ,     
unsigned char Button_ks;                   //        
bit one_click_ks=1;
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//   .   .     
// number_scan_size                 
//      .
void key_scan(unsigned char *cod_char)
{ 
 bit Butt_pres=0;
 char Buttemp[2], w;

 switch (N_scan)
  { 
    case 0: 
     {
       if (key_1==0) {Button_ks=1; N_scan++; } else 
       if (key_2==0) {Button_ks=2; N_scan++; } else Button_ks=0;
     } break; 
    case number_scan_size :
     {
       if (key_1==0) Buttemp[0]=1; else Buttemp[0]=0; 
       if (key_2==0) Buttemp[1]=2; else Buttemp[1]=0;
       for(w=0;w<2;w++) if (Buttemp[w]==Button_ks) Butt_pres=1;
       if (Butt_pres)
        {  
          if (one_click_ks) {*cod_char=Button_ks; one_click_ks=0;}
        }
       else
        {  
           N_scan=0; 
           one_click_ks=1;
        }
     } break;
    default: 
     {
       if (key_1==0) Buttemp[0]=1; else Buttemp[0]=0; 
       if (key_2==0) Buttemp[1]=2; else Buttemp[1]=0;
       for(w=0;w<2;w++) if (Buttemp[w]==Button_ks) Butt_pres=1;
       if ((Butt_pres)&&(N_scan<number_scan_size)) N_scan++; else N_scan=0;
     }
  }
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   

